# -*- coding: utf-8 -*-
from setuphelpers import *
import time

"""
{
    "key": "EduPython_3.14_is1",
    "name": "EduPython 3.14",
    "version": "3.14",
    "install_date": "2024-04-18 00:00:00",
    "install_location": "C:\\Program Files\\EduPython\\",
    "uninstall_string": '"C:\\Program Files\\EduPython\\unins000.exe"',
    "publisher": "V. MAILLE",
    "system_component": 0,
    "win64": false,
}
{
    "key": "EduPython_3.14_is1",
    "name": "EduPython 3.14",
    "version": "3.14",
    "install_date": "2024-04-18 00:00:00",
    "install_location": "C:\\EduPython\\",
    "uninstall_string": '"C:\\EduPython\\unins000.exe"',
    "publisher": "V. MAILLE",
    "system_component": 0,
    "win64": false,
}


List of setup parameters:
https://jrsoftware.org/ishelp/index.php?topic=setupcmdline

List of uninstall parameters:
https://jrsoftware.org/ishelp/index.php?topic=uninstcmdline

"""
# app_dir = makepath(programfiles32, "EduPython")  # user may encounter right issues
app_dir = makepath(systemdrive, "EduPython")


def install():
    bin_name = glob.glob("Setup_EP*.exe")[0]

    # Uninstall other versions of the software if not installed in app_dir
    for to_uninstall in installed_softwares("EduPython_"):
        install_app_dir = makepath(to_uninstall["install_location"], os.sep)
        if makepath(to_uninstall["install_location"], os.sep) != makepath(app_dir, os.sep) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])

    # Installing the software
    install_exe_if_needed(
        bin_name,
        silentflags=f'/VERYSILENT /SUPPRESSMSGBOXES /NORESTART /ALLUSERS /DIR="{app_dir}"',
        key="EduPython_%s_is1" % control.get_software_version(),
        min_version=control.get_software_version(),
        timeout=900,
    )


def uninstall():
    if isdir(app_dir):
        killalltasks(ensure_list(control.impacted_process))
        remove_tree(app_dir)
