# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    api_url = "https://sourceforge.net/projects/git-osx-installer/best_release.json"
    update_dict = {
        # "bin_contains": {
        #     "x64": "-x64-svn-",
        #     "arm64": "-ARM64-svn-",
        #     "x86": "-win32-svn-",
        # },
        "latest_bin_to_substitute": {
            "x64": "TortoiseSVN-%s-x64-svn-1.14.3.msi",
            "arm64": "TortoiseSVN-%s-ARM64-svn-1.14.3.msi",
            "x86": "TortoiseSVN-%s-win32-svn-1.14.3.msi",
        },
    }

    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = wgets(api_url, proxies=proxies, as_json=True)
    for to_download in json_load["platform_releases"]:
        if update_dict[control.target_os + "-" + ensure_list(control.architecture)[0]] in to_download["name"]:
            latest_bin = json_load["platform_releases"][to_download]["filename"].split("/")[-1]
            download_url = json_load["platform_releases"][to_download]["url"].replace("http://", "https://")
            version = json_load["platform_releases"][to_download]["filename"].split("-")[1]
            break

    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = wgets(api_url, proxies=proxies, as_json=True)
    version = json_load["platform_releases"]["windows"]["filename"].split("-")[1]
    # latest_bin = json_load["platform_releases"]["windows"]["url"].split("/")[7].split("?")[0]
    latest_bin = update_dict["latest_bin_to_substitute"][control.architecture] % version
    partial_download_url = json_load["platform_releases"]["windows"]["url"].replace("http://", "https://").rsplit("/", 1)[0]
    download_url = partial_download_url + "/" + latest_bin

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)

    # Checking version from file
    if get_os_name() == "Windows" and "windows" in control.target_os.lower():
        # version_from_file = get_version_from_binary(latest_bin, property_name='ProductName').split(" ")[1]
        version_from_file = get_version_from_binary(latest_bin)
        if Version(version_from_file, 4) != Version(version, 4) and version_from_file != "":
            error("ERROR: Binary file version do NOT corresponds to online version")
        else:
            print("INFO: Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
